/* -*- buffer-read-only: t -*- vi: set ro:
#line 382
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 382
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_poll.m4"
/* This file is part of mailfrom filter.             -*- c -*-
#line 17
   Copyright (C) 2006 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

static size_t last_poll_host_loc
#line 19 "bi_poll.m4"
;
static size_t last_poll_send_loc
#line 20 "bi_poll.m4"
;
static size_t last_poll_recv_loc
#line 21 "bi_poll.m4"
;
static size_t cache_used_loc
#line 22 "bi_poll.m4"
;

void
set_last_poll_result(eval_environ_t env,
		     const char *host_addr,
		     const char *send, const char *recv)
{
	char *s;

	s = host_addr ? strcpy(heap_reserve(env, strlen(host_addr) + 1), host_addr) : NULL;
	*env_var_ref(env, last_poll_host_loc) = (STKVAL) (s);
	s = send ? strcpy(heap_reserve(env, strlen(send) + 1), send) : NULL;
	*env_var_ref(env, last_poll_send_loc) = (STKVAL) (s);
	s = recv ? strcpy(heap_reserve(env, strlen(recv) + 1), recv) : NULL;
	*env_var_ref(env, last_poll_recv_loc) = (STKVAL) (s);
}

void
set_cache_used(eval_environ_t env, int value)
{
	*env_var_ref(env, cache_used_loc) = (STKVAL) (value);
}


void
#line 46
bi_stdpoll(eval_environ_t env)
#line 46 "bi_poll.m4"
{
#line 46
	
#line 46
char * email = (char *) get_arg(env, 2);
#line 46
        char * ehlo = (char *) get_arg(env, 1);
#line 46
        char * mailfrom = (char *) get_arg(env, 0);
#line 46
        
#line 46
        adjust_stack(env, 3);
#line 46

#line 46
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 46
		prog_trace(env, "stdpoll %s %s %s",email, ehlo, mailfrom);;
#line 46

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STANDARD POLL FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, ehlo, mailfrom);
	rc = method_standard(env, email, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
			do {
#line 57
		if (env_catch(env, rc) == 0)
#line 57
			return ;
#line 57
		else
#line 57
			runtime_error(env,
#line 57
				                                                  "stdpoll: " "unhandled exception %s",mf_status_str(rc));
#line 57
	} while (0) 
#line 57
;
#line 57
;
			
	do {
#line 59
push(env, (STKVAL) (rc));
#line 59
return;
#line 59
} while (0);	
}
}

#line 64
void
#line 64
bi_strictpoll(eval_environ_t env)
#line 64 "bi_poll.m4"
{
#line 64
	
#line 64
char * host = (char *) get_arg(env, 3);
#line 64
        char * email = (char *) get_arg(env, 2);
#line 64
        char * ehlo = (char *) get_arg(env, 1);
#line 64
        char * mailfrom = (char *) get_arg(env, 0);
#line 64
        
#line 64
        adjust_stack(env, 4);
#line 64

#line 64
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 64
		prog_trace(env, "strictpoll %s %s %s %s",host, email, ehlo, mailfrom);;
#line 64

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STRICT POLL FOR %s HOST %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = method_strict(env, email, host, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
			do {
#line 77
		if (env_catch(env, rc) == 0)
#line 77
			return ;
#line 77
		else
#line 77
			runtime_error(env,
#line 77
				                                                  "strictpoll: " "unhandled exception %s",mf_status_str(rc));
#line 77
	} while (0) 
#line 77
;
#line 77
;
	
	do {
#line 79
push(env, (STKVAL) (rc));
#line 79
return;
#line 79
} while (0);	
}
}

#line 84
void
#line 84
bi__pollhost(eval_environ_t env)
#line 84 "bi_poll.m4"
{
#line 84
	
#line 84
char * host = (char *) get_arg(env, 3);
#line 84
        char * email = (char *) get_arg(env, 2);
#line 84
        char * ehlo = (char *) get_arg(env, 1);
#line 84
        char * mailfrom = (char *) get_arg(env, 0);
#line 84
        
#line 84
        adjust_stack(env, 4);
#line 84

#line 84
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 84
		prog_trace(env, "_pollhost %s %s %s %s",host, email, ehlo, mailfrom);;
#line 84

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLHOST %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = check_on_host(env, email, host, ehlo, mailfrom);

		if (!(mf_resolved(rc)))
			do {
#line 98
		if (env_catch(env, rc) == 0)
#line 98
			return ;
#line 98
		else
#line 98
			runtime_error(env,
#line 98
				                                                  "_pollhost: " "unhandled exception %s",mf_status_str(rc));
#line 98
	} while (0) 
#line 98
;
#line 98
;
	
	do {
#line 100
push(env, (STKVAL) (rc));
#line 100
return;
#line 100
} while (0);	
}
}

#line 105
void
#line 105
bi__pollmx(eval_environ_t env)
#line 105 "bi_poll.m4"
{
#line 105
	
#line 105
char * domain = (char *) get_arg(env, 3);
#line 105
        char * email = (char *) get_arg(env, 2);
#line 105
        char * ehlo = (char *) get_arg(env, 1);
#line 105
        char * mailfrom = (char *) get_arg(env, 0);
#line 105
        
#line 105
        adjust_stack(env, 4);
#line 105

#line 105
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 105
		prog_trace(env, "_pollmx %s %s %s %s",domain, email, ehlo, mailfrom);;
#line 105

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLMX %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      domain, email, ehlo, mailfrom);

	rc = check_mx_records(env, email, domain, ehlo, mailfrom, NULL);

		if (!(mf_resolved(rc)))
			do {
#line 118
		if (env_catch(env, rc) == 0)
#line 118
			return ;
#line 118
		else
#line 118
			runtime_error(env,
#line 118
				                                                  "_pollmx: " "unhandled exception %s",mf_status_str(rc));
#line 118
	} while (0) 
#line 118
;
#line 118
;

	do {
#line 120
push(env, (STKVAL) (rc));
#line 120
return;
#line 120
} while (0);	
}
}


#line 124
void
#line 124
poll_init_builtin()
#line 124
{
#line 124
	#line 19 "bi_poll.m4"
	last_poll_host_loc = builtin_variable_install("last_poll_host", dtype_string, VAR_VOLATILE)->off;
#line 20 "bi_poll.m4"
	last_poll_send_loc = builtin_variable_install("last_poll_send", dtype_string, VAR_VOLATILE)->off;
#line 21 "bi_poll.m4"
	last_poll_recv_loc = builtin_variable_install("last_poll_recv", dtype_string, VAR_VOLATILE)->off;
#line 22 "bi_poll.m4"
	cache_used_loc = builtin_variable_install("cache_used", dtype_number, VAR_VOLATILE)->off;
#line 46 "bi_poll.m4"
va_builtin_install_ex("stdpoll", bi_stdpoll, 0, 0, dtype_number,  3, 0,  dtype_string, dtype_string, dtype_string);
#line 64 "bi_poll.m4"
va_builtin_install_ex("strictpoll", bi_strictpoll, 0, 0, dtype_number,  4, 0,  dtype_string, dtype_string, dtype_string, dtype_string);
#line 84 "bi_poll.m4"
va_builtin_install_ex("_pollhost", bi__pollhost, 0, 0, dtype_number,  4, 0,  dtype_string, dtype_string, dtype_string, dtype_string);
#line 105 "bi_poll.m4"
va_builtin_install_ex("_pollmx", bi__pollmx, 0, 0, dtype_number,  4, 0,  dtype_string, dtype_string, dtype_string, dtype_string);

#line 124 "bi_poll.m4"
		
#line 124
}
#line 0

#line 0

